3 # Rewrite revision history
4 # Copyright (c) Petr Baudis, 2006
5 # Minimal changes to "port" it to core-git (c) Johannes Schindelin, 2007
7 # Lets you rewrite the revision history of the current branch, creating
8 # a new branch. You can specify a number of filters to modify the commits,
11 # The following functions will also be available in the commit filter:
13 functions
=$
(cat << \EOF
20 # if it was not rewritten, take the original
21 if test -r "$workdir/../map/$1"
23 cat "$workdir/../map/$1"
29 # if you run 'skip_commit "$@"' in a commit filter, it will print
30 # the (mapped) parents, effectively skipping the commit.
43 # if you run 'git_commit_non_empty_tree "$@"' in a commit filter,
44 # it will skip commits that leave the tree untouched, commit the other.
45 git_commit_non_empty_tree
()
47 if test $# = 3 && test "$1" = $
(git rev-parse
"$3^{tree}"); then
53 # override die(): this version puts in an extra line break, so that
54 # the progress is still visible
67 # When piped a commit, output a script to set the ident of either
68 # "author" or "committer
71 lid
="$(echo "$1" | tr "[A-Z
]" "[a-z
]")"
72 uid
="$(echo "$1" | tr "[a-z
]" "[A-Z
]")"
77 s/^'$lid' \([^<]*\) <[^>]*> .*$/\1/
79 s
/.
*/GIT_
'$uid'_NAME
='\''&'\''; export GIT_
'$uid'_NAME
/p
82 s
/^
'$lid' [^
<]* <\
([^
>]*\
)> .
*$
/\
1/
84 s/.*/GIT_'$uid'_EMAIL='\''&'\''; export GIT_'$uid'_EMAIL/p
87 s/^'$lid' [^<]* <[^>]*> \(.*\)$/\1/
89 s
/.
*/GIT_
'$uid'_DATE
='\''&'\''; export GIT_
'$uid'_DATE
/p
95 LANG=C LC_ALL=C sed -ne "$pick_id_script"
96 # Ensure non-empty id name.
97 echo "case \"\$GIT_${uid}_NAME\" in \"\") GIT_${uid}_NAME=\"\${GIT_${uid}_EMAIL%%@*}\" && export GIT_${uid}_NAME;; esac"
100 USAGE="[--env-filter <command>] [--tree-filter <command>]
101 [--index-filter <command>] [--parent-filter <command>]
102 [--msg-filter <command>] [--commit-filter <command>]
103 [--tag-name-filter <command>] [--subdirectory-filter <directory>]
104 [--original <namespace>] [-d <directory>] [-f | --force]
105 [<rev-list options>...]"
110 if [ "$(is_bare_repository)" = false ]; then
111 git diff-files --ignore-submodules --quiet &&
112 git diff-index --cached --quiet HEAD -- ||
113 die "Cannot rewrite branch(es) with a dirty working directory."
125 orig_namespace=refs/original/
151 # all switches take one argument
153 case "$#" in 1) usage ;; esac
166 filter_tree="$OPTARG"
169 filter_index="$OPTARG"
172 filter_parent="$OPTARG"
178 filter_commit="$functions; $OPTARG"
181 filter_tag_name="$OPTARG"
183 --subdirectory-filter)
184 filter_subdir="$OPTARG"
187 orig_namespace=$(expr "$OPTARG/" : '\
(.
*[^
/]\
)/*$
')/
195 case "$prune_empty,$filter_commit" in
197 filter_commit='git commit-tree
"$@"';;
199 filter_commit="$functions;"' git_commit_non_empty_tree
"$@"';;
203 die "Cannot set --prune-empty and --filter-commit at the same time"
211 test -d "$tempdir" &&
212 die "$tempdir already exists, please remove it"
214 mkdir -p "$tempdir/t" &&
215 tempdir="$(cd "$tempdir"; pwd)" &&
220 # Remove tempdir on exit
221 trap 'cd ..
/..
; rm -rf "$tempdir"' 0
223 ORIG_GIT_DIR="$GIT_DIR"
224 ORIG_GIT_WORK_TREE="$GIT_WORK_TREE"
225 ORIG_GIT_INDEX_FILE="$GIT_INDEX_FILE"
227 export GIT_DIR GIT_WORK_TREE
229 # Make sure refs/original is empty
230 git for-each-ref > "$tempdir"/backup-refs || exit
231 while read sha1 type name
233 case "$force,$name" in
235 die "Cannot create a new backup.
236 A previous backup already exists in $orig_namespace
237 Force overwriting the backup with -f"
240 git update-ref -d "$name" $sha1
243 done < "$tempdir"/backup-refs
245 # The refs should be updated if their heads were rewritten
246 git rev-parse --no-flags --revs-only --symbolic-full-name \
247 --default HEAD "$@" > "$tempdir"/raw-heads || exit
248 sed -e '/^^
/d
' "$tempdir"/raw-heads >"$tempdir"/heads
250 test -s "$tempdir"/heads ||
251 die "Which ref do you want to rewrite?"
253 GIT_INDEX_FILE="$(pwd)/../index"
254 export GIT_INDEX_FILE
255 git read-tree || die "Could not seed the index"
257 # map old->new commit ids for rewriting parents
258 mkdir ../map || die "Could not create map/ directory"
260 case "$filter_subdir" in
262 git rev-list --reverse --topo-order --default HEAD \
263 --parents --simplify-merges "$@"
266 git rev-list --reverse --topo-order --default HEAD \
267 --parents --simplify-merges "$@" -- "$filter_subdir"
268 esac > ../revs || die "Could not get the commits"
269 commits=$(wc -l <../revs | tr -d " ")
271 test $commits -eq 0 && die "Found nothing to rewrite"
273 # Rewrite the commits
275 git_filter_branch__commit_count=0
276 while read commit parents; do
277 git_filter_branch__commit_count=$(($git_filter_branch__commit_count+1))
278 printf "\rRewrite $commit ($git_filter_branch__commit_count/$commits)"
280 case "$filter_subdir" in
282 git read-tree -i -m $commit
285 # The commit may not have the subdirectory at all
286 err=$(git read-tree -i -m $commit:"$filter_subdir" 2>&1) || {
287 if ! git rev-parse -q --verify $commit:"$filter_subdir"
289 rm -f "$GIT_INDEX_FILE"
295 esac || die "Could not initialize the index"
299 git cat-file commit "$commit" >../commit ||
300 die "Cannot read commit $commit"
302 eval "$(set_ident AUTHOR <../commit)" ||
303 die "setting author failed for commit $commit"
304 eval "$(set_ident COMMITTER <../commit)" ||
305 die "setting committer failed for commit $commit"
306 eval "$filter_env" < /dev/null ||
307 die "env filter failed: $filter_env"
309 if [ "$filter_tree" ]; then
310 git checkout-index -f -u -a ||
311 die "Could not checkout the index"
312 # files that $commit removed are now still in the working tree;
313 # remove them, else they would be added again
314 git clean -d -q -f -x
315 eval "$filter_tree" < /dev/null ||
316 die "tree filter failed: $filter_tree"
319 git diff-index -r --name-only $commit &&
320 git ls-files --others
321 ) > "$tempdir"/tree-state || exit
322 git update-index --add --replace --remove --stdin \
323 < "$tempdir"/tree-state || exit
326 eval "$filter_index" < /dev/null ||
327 die "index filter failed: $filter_index"
330 for parent in $parents; do
331 for reparent in $(map "$parent"); do
332 parentstr="$parentstr -p $reparent"
335 if [ "$filter_parent" ]; then
336 parentstr="$(echo "$parentstr" | eval "$filter_parent")" ||
337 die "parent filter failed: $filter_parent"
340 sed -e '1,/^$
/d
' <../commit | \
341 eval "$filter_msg" > ../message ||
342 die "msg filter failed: $filter_msg"
343 @SHELL_PATH@ -c "$filter_commit" "git commit-tree" \
344 $(git write-tree) $parentstr < ../message > ../map/$commit ||
345 die "could not write rewritten commit"
348 # In case of a subdirectory filter, it is possible that a specified head
349 # is not in the set of rewritten commits, because it was pruned by the
350 # revision walker. Fix it by mapping these heads to the unique nearest
351 # ancestor that survived the pruning.
353 if test "$filter_subdir"
357 sha1=$(git rev-parse "$ref"^0)
358 test -f "$workdir"/../map/$sha1 && continue
359 ancestor=$(git rev-list --simplify-merges -1 \
360 $ref -- "$filter_subdir")
361 test "$ancestor" && echo $(map $ancestor) >> "$workdir"/../map/$sha1
362 done < "$tempdir"/heads
365 # Finally update the refs
367 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
368 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
372 # avoid rewriting a ref twice
373 test -f "$orig_namespace$ref" && continue
375 sha1=$(git rev-parse "$ref"^0)
376 rewritten=$(map $sha1)
378 test $sha1 = "$rewritten" &&
379 warn "WARNING: Ref '$ref' is unchanged" &&
384 echo "Ref '$ref' was deleted"
385 git update-ref -m "filter-branch: delete" -d "$ref" $sha1 ||
386 die "Could not delete $ref"
389 echo "Ref '$ref' was rewritten"
390 if ! git update-ref -m "filter-branch: rewrite" \
391 "$ref" $rewritten $sha1 2>/dev/null; then
392 if test $(git cat-file -t "$ref") = tag; then
393 if test -z "$filter_tag_name"; then
394 warn "WARNING: You said to rewrite tagged commits, but not the corresponding tag."
395 warn "WARNING: Perhaps use '--tag-name-filter cat' to rewrite the tag."
398 die "Could not rewrite $ref"
403 # NEEDSWORK: possibly add -Werror, making this an error
404 warn "WARNING: '$ref' was rewritten into multiple commits:"
406 warn "WARNING: Ref '$ref' points to the first one now."
407 rewritten=$(echo "$rewritten" | head -n 1)
408 git update-ref -m "filter-branch: rewrite to first" \
409 "$ref" $rewritten $sha1 ||
410 die "Could not rewrite $ref"
413 git update-ref -m "filter-branch: backup" "$orig_namespace$ref" $sha1 ||
415 done < "$tempdir"/heads
417 # TODO: This should possibly go, with the semantics that all positive given
418 # refs are updated, and their original heads stored in refs/original/
421 if [ "$filter_tag_name" ]; then
422 git for-each-ref --format='%(objectname
) %(objecttype
) %(refname
)' refs/tags |
423 while read sha1 type ref; do
424 ref="${ref#refs/tags/}"
425 # XXX: Rewrite tagged trees as well?
426 if [ "$type" != "commit" -a "$type" != "tag" ]; then
430 if [ "$type" = "tag" ]; then
431 # Dereference to a commit
433 sha1="$(git rev-parse -q "$sha1"^{commit})" || continue
436 [ -f "../map/$sha1" ] || continue
437 new_sha1="$(cat "../map/$sha1")"
440 new_ref="$(echo "$ref" | eval "$filter_tag_name")" ||
441 die "tag name filter failed: $filter_tag_name"
443 echo "$ref -> $new_ref ($sha1 -> $new_sha1)"
445 if [ "$type" = "tag" ]; then
446 new_sha1=$( ( printf 'object
%s
\ntype commit
\ntag
%s
\n' \
447 "$new_sha1" "$new_ref"
448 git cat-file tag "$ref" |
455 -e '/^
-----BEGIN PGP SIGNATURE----
-/q
' \
458 die "Could not create new tag object for $ref"
459 if git cat-file tag "$ref" | \
460 grep '^
-----BEGIN PGP SIGNATURE-----
' >/dev/null 2>&1
462 warn "gpg signature stripped from tag object $sha1t"
466 git update-ref "refs/tags/$new_ref" "$new_sha1" ||
467 die "Could not write tag $new_ref"
476 unset GIT_DIR GIT_WORK_TREE GIT_INDEX_FILE
477 test -z "$ORIG_GIT_DIR" || {
478 GIT_DIR="$ORIG_GIT_DIR" && export GIT_DIR
480 test -z "$ORIG_GIT_WORK_TREE" || {
481 GIT_WORK_TREE="$ORIG_GIT_WORK_TREE" &&
484 test -z "$ORIG_GIT_INDEX_FILE" || {
485 GIT_INDEX_FILE="$ORIG_GIT_INDEX_FILE" &&
486 export GIT_INDEX_FILE
489 if [ "$(is_bare_repository)" = false ]; then
490 git read-tree -u -m HEAD || exit